diff -Nru dnsdiag-1.7.0/debian/changelog dnsdiag-1.7.0/debian/changelog
--- dnsdiag-1.7.0/debian/changelog	2020-02-08 20:16:44.000000000 +0200
+++ dnsdiag-1.7.0/debian/changelog	2021-11-23 17:49:52.000000000 +0200
@@ -1,3 +1,12 @@
+dnsdiag (1.7.0-1.1) unstable; urgency=medium
+
+  * Non-maintainer upload.
+  * Add upstream fix for runtime warning with dnspython 2.
+    (Closes: #995015)
+  * Build depend on python3, not python3-all.
+
+ -- Adrian Bunk <bunk@debian.org>  Tue, 23 Nov 2021 17:49:52 +0200
+
 dnsdiag (1.7.0-1) unstable; urgency=medium
 
   [ Ondřej Nový ]
diff -Nru dnsdiag-1.7.0/debian/control dnsdiag-1.7.0/debian/control
--- dnsdiag-1.7.0/debian/control	2020-02-08 20:16:44.000000000 +0200
+++ dnsdiag-1.7.0/debian/control	2021-11-23 17:49:52.000000000 +0200
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Ana Custura <ana@netstat.org.uk>
 Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends: debhelper-compat (= 11), dh-python, python3-all, python3-setuptools, dh-exec
+Build-Depends: debhelper-compat (= 11), dh-python, python3, python3-setuptools, dh-exec
 Standards-Version: 4.4.1
 Homepage: https://dnsdiag.org/
 Vcs-Git: https://salsa.debian.org/python-team/modules/dnsdiag.git
diff -Nru dnsdiag-1.7.0/debian/patches/0001-Adapt-new-dnspython-v2.0.0.patch dnsdiag-1.7.0/debian/patches/0001-Adapt-new-dnspython-v2.0.0.patch
--- dnsdiag-1.7.0/debian/patches/0001-Adapt-new-dnspython-v2.0.0.patch	1970-01-01 02:00:00.000000000 +0200
+++ dnsdiag-1.7.0/debian/patches/0001-Adapt-new-dnspython-v2.0.0.patch	2021-11-23 17:48:29.000000000 +0200
@@ -0,0 +1,82 @@
+From 3d9eb79e0037837586be5e3d01ffecbe3c442065 Mon Sep 17 00:00:00 2001
+From: Babak Farrokhi <babak@farrokhi.net>
+Date: Thu, 20 Aug 2020 23:47:11 +0200
+Subject: Adapt new dnspython v2.0.0
+
+- Adapt new resolve() function (Fixes #67)
+- Update dependency to newer dnspython
+---
+ dnseval.py       | 4 ++--
+ dnsping.py       | 4 ++--
+ dnstraceroute.py | 2 +-
+ requirements.txt | 2 +-
+ setup.py         | 2 +-
+ 5 files changed, 7 insertions(+), 7 deletions(-)
+
+diff --git a/dnseval.py b/dnseval.py
+index d3d0afb..63820c6 100755
+--- a/dnseval.py
++++ b/dnseval.py
+@@ -172,8 +172,8 @@ def dnsping(host, server, dnsrecord, timeout, count, use_tcp=False, use_edns=Fal
+                 fqdn = host
+ 
+             stime = time.perf_counter()
+-            answers = resolver.query(fqdn, dnsrecord, tcp=use_tcp,
+-                                     raise_on_no_answer=False)  # todo: response validation in future
++            answers = resolver.resolve(fqdn, dnsrecord, tcp=use_tcp,
++                                       raise_on_no_answer=False)  # todo: response validation in future
+ 
+         except (dns.resolver.NoNameservers, dns.resolver.NoAnswer):
+             break
+diff --git a/dnsping.py b/dnsping.py
+index 6845cdb..a243ab5 100755
+--- a/dnsping.py
++++ b/dnsping.py
+@@ -186,8 +186,8 @@ def main():
+ 
+         try:
+             stime = time.perf_counter()
+-            answers = resolver.query(hostname, dnsrecord, source_port=src_port, source=src_ip, tcp=use_tcp,
+-                                     raise_on_no_answer=False)
++            answers = resolver.resolve(hostname, dnsrecord, source_port=src_port, source=src_ip, tcp=use_tcp,
++                                       raise_on_no_answer=False)
+             etime = time.perf_counter()
+         except dns.resolver.NoNameservers as e:
+             if not quiet:
+diff --git a/dnstraceroute.py b/dnstraceroute.py
+index 8a58e40..44a4770 100755
+--- a/dnstraceroute.py
++++ b/dnstraceroute.py
+@@ -194,7 +194,7 @@ def ping(resolver, hostname, dnsrecord, ttl, src_ip, use_edns=False):
+         resolver.use_edns(edns=0, payload=8192, ednsflags=dns.flags.edns_from_text('DO'))
+ 
+     try:
+-        resolver.query(hostname, dnsrecord, source=src_ip, raise_on_no_answer=False)
++        resolver.resolve(hostname, dnsrecord, source=src_ip, raise_on_no_answer=False)
+ 
+     except dns.resolver.NoNameservers as e:
+         if not quiet:
+diff --git a/requirements.txt b/requirements.txt
+index 7fe56ca..f1238bd 100644
+--- a/requirements.txt
++++ b/requirements.txt
+@@ -1,2 +1,2 @@
+-dnspython>=1.16.0
++dnspython>=2.0.0
+ cymruwhois>=1.6
+diff --git a/setup.py b/setup.py
+index 39233d2..2db02ca 100644
+--- a/setup.py
++++ b/setup.py
+@@ -5,7 +5,7 @@ setup(
+     version="1.7.0",
+     packages=find_packages(),
+     scripts=["dnseval.py", "dnsping.py", "dnstraceroute.py"],
+-    install_requires=['dnspython>=1.16.0', 'cymruwhois>=1.6'],
++    install_requires=['dnspython>=2.0.0', 'cymruwhois>=1.6'],
+ 
+     classifiers=[
+         "Topic :: System :: Networking",
+-- 
+2.20.1
+
diff -Nru dnsdiag-1.7.0/debian/patches/series dnsdiag-1.7.0/debian/patches/series
--- dnsdiag-1.7.0/debian/patches/series	2020-02-08 19:52:07.000000000 +0200
+++ dnsdiag-1.7.0/debian/patches/series	2021-11-23 17:49:52.000000000 +0200
@@ -1 +1,2 @@
 consolescripts.diff
+0001-Adapt-new-dnspython-v2.0.0.patch
